Package org.picocontainer.behaviors

# Class Intercepted<T>

java.lang.Object
org.picocontainer.behaviors.AbstractBehavior
org.picocontainer.behaviors.HiddenImplementation
org.picocontainer.behaviors.Intercepted<T>

All Implemented Interfaces:
  `Serializable`, `Behavior`, `ComponentAdapter`, `ComponentLifecycle`, `ComponentMonitorStrategy`, `LifecycleStrategy`

public class Intercepted<T> extends HiddenImplementation

Author:
  Paul Hammant
See Also:
  - Serialized Form

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`static interface`
`Intercepted.Controller`
`static class`
`Intercepted.ControllerImpl`
`class`
`Intercepted.ControllerWrapper`
`static class`
`Intercepted.InterceptorThreadLocal`

## Nested classes/interfaces inherited from interface org.picocontainer.ComponentAdapter

`ComponentAdapter.NOTHING`

## Field Summary

### Fields inherited from class org.picocontainer.behaviors.AbstractBehavior

`delegate`

## Constructor Summary

Constructors
Constructor
Description
`Intercepted(ComponentAdapter delegate)`

## Method Summary

Modifier and Type
Method
Description
`void`
`addPostInvocation(Class type, Object interceptor)`
`void`
`addPreInvocation(Class type, Object interceptor)`
`Intercepted.Controller`
`getController()`
`String`
`getDescriptor()`
Get a string key descriptor of the component adapter for use in toString()
`protected Object`
`invokeMethod(Object componentInstance, Method method, Object[] args, PicoContainer container)`

### Methods inherited from class org.picocontainer.behaviors.HiddenImplementation

`createProxy, getComponentInstance`

### Methods inherited from class org.picocontainer.behaviors.AbstractBehavior

`accept, changeMonitor, componentHasLifecycle, currentMonitor, dispose, dispose, findAdapterOfType, getComponentImplementation, getComponentInstance, getComponentKey, getDelegate, hasLifecycle, isLazy, isStarted, start, start, stop, stop, toString, verify`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### Intercepted

public Intercepted(ComponentAdapter delegate)

## Method Details

### addPreInvocation

public void addPreInvocation(Class type, Object interceptor)

### addPostInvocation

public void addPostInvocation(Class type, Object interceptor)

### invokeMethod

protected Object invokeMethod(Object componentInstance, Method method, Object[] args, PicoContainer container) throws Throwable

Overrides:
  `invokeMethod` in class `HiddenImplementation`
Throws:
  `Throwable`

### getController

public Intercepted.Controller getController()

### getDescriptor

public String getDescriptor()
Description copied from interface: `ComponentAdapter`
Get a string key descriptor of the component adapter for use in toString()

Specified by:
  `getDescriptor` in interface `ComponentAdapter<T>`
Overrides:
  `getDescriptor` in class `HiddenImplementation`
Returns:
  the descriptor